com.hazelcast.com.fasterxml.jackson.core.util

## Class JsonGeneratorDelegate

- java.lang.Object
- - com.hazelcast.com.fasterxml.jackson.core.JsonGenerator
  - - com.hazelcast.com.fasterxml.jackson.core.util.JsonGeneratorDelegate

- All Implemented Interfaces:
    Versioned, Closeable, Flushable, AutoCloseable
  Direct Known Subclasses:
    FilteringGeneratorDelegate

      public class JsonGeneratorDelegate
      extends JsonGenerator

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonGenerator

      `JsonGenerator.Feature`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonGenerator` | `delegate` Delegate object that method calls are delegated to.
    `protected boolean` | `delegateCopyMethods` Whether copy methods (`copyCurrentEvent(com.hazelcast.com.fasterxml.jackson.core.JsonParser)`, `copyCurrentStructure(com.hazelcast.com.fasterxml.jackson.core.JsonParser)`, `writeTree(com.hazelcast.com.fasterxml.jackson.core.TreeNode)` and `writeObject(java.lang.Object)`) are to be called (true), or handled by this object (false).

    - ### Fields inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonGenerator

      `_cfgPrettyPrinter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JsonGeneratorDelegate(JsonGenerator d)`
    `JsonGeneratorDelegate(JsonGenerator d, boolean delegateCopyMethods)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canOmitFields()` Introspection method to call to check whether it is ok to omit writing of Object fields or not.
    `boolean` | `canUseSchema(FormatSchema schema)` Method that can be used to verify that given schema can be used with this generator (using `JsonGenerator.setSchema(com.hazelcast.com.fasterxml.jackson.core.FormatSchema)`).
    `boolean` | `canWriteBinaryNatively()` Introspection method that may be called to see if the underlying data format supports "native" binary data; that is, an efficient output of binary content without encoding.
    `boolean` | `canWriteObjectId()` Introspection method that may be called to see if the underlying data format supports some kind of Object Ids natively (many do not; for example, JSON doesn't).
    `boolean` | `canWriteTypeId()` Introspection method that may be called to see if the underlying data format supports some kind of Type Ids natively (many do not; for example, JSON doesn't).
    `void` | `close()` Method called to close this generator, so that no more content can be written.
    `void` | `copyCurrentEvent(JsonParser p)` Method for copying contents of the current event that the given parser instance points to.
    `void` | `copyCurrentStructure(JsonParser p)` Method for copying contents of the current event and following events that it encloses the given parser instance points to.
    `JsonGenerator` | `disable(JsonGenerator.Feature f)` Method for disabling specified features (check `JsonGenerator.Feature` for list of features)
    `JsonGenerator` | `enable(JsonGenerator.Feature f)` Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.
    `void` | `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
    `CharacterEscapes` | `getCharacterEscapes()` Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.
    `ObjectCodec` | `getCodec()` Method for accessing the object used for writing Java object as JSON content (using method `JsonGenerator.writeObject(java.lang.Object)`).
    `Object` | `getCurrentValue()` Helper method, usually equivalent to: `getOutputContext().getCurrentValue();`
    `JsonGenerator` | `getDelegate()`
    `int` | `getFeatureMask()` Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.
    `int` | `getHighestEscapedChar()` Accessor method for testing what is the highest unescaped character configured for this generator.
    `int` | `getOutputBuffered()` Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available.
    `JsonStreamContext` | `getOutputContext()`
    `Object` | `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
    `PrettyPrinter` | `getPrettyPrinter()` Accessor for checking whether this generator has a configured `PrettyPrinter`; returns it if so, null if none configured.
    `FormatSchema` | `getSchema()` Method for accessing Schema that this parser uses, if any.
    `boolean` | `isClosed()` Method that can be called to determine whether this generator is closed or not.
    `boolean` | `isEnabled(JsonGenerator.Feature f)` Method for checking whether given feature is enabled.
    `JsonGenerator` | `overrideFormatFeatures(int values, int mask)` Bulk set method for (re)setting states of `FormatFeature`s, by specifying values (set / clear) along with a mask, to determine which features to change, if any.
    `JsonGenerator` | `overrideStdFeatures(int values, int mask)` Bulk set method for (re)setting states of features specified by `mask`.
    `JsonGenerator` | `setCharacterEscapes(CharacterEscapes esc)` Method for defining custom escapes factory uses for `JsonGenerator`s it creates.
    `JsonGenerator` | `setCodec(ObjectCodec oc)` Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).
    `void` | `setCurrentValue(Object v)` Helper method, usually equivalent to: `getOutputContext().setCurrentValue(v);`
    `JsonGenerator` | `setFeatureMask(int mask)` Deprecated.
    `JsonGenerator` | `setHighestNonEscapedChar(int charCode)` Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1).
    `JsonGenerator` | `setPrettyPrinter(PrettyPrinter pp)` Method for setting a custom pretty printer, which is usually used to add indentation for improved human readability.
    `JsonGenerator` | `setRootValueSeparator(SerializableString sep)` Method that allows overriding String used for separating root-level JSON values (default is single space character)
    `void` | `setSchema(FormatSchema schema)` Method to call to make this generator use specified schema.
    `JsonGenerator` | `useDefaultPrettyPrinter()` Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
    `Version` | `version()` Accessor for finding out version of the bundle that provided this generator instance.
    `void` | `writeArray(double[] array, int offset, int length)` Value write method that can be called to write a single array (sequence of `JsonToken.START_ARRAY`, zero or more `JsonToken.VALUE_NUMBER_FLOAT`, `JsonToken.END_ARRAY`)
    `void` | `writeArray(int[] array, int offset, int length)` Value write method that can be called to write a single array (sequence of `JsonToken.START_ARRAY`, zero or more `JsonToken.VALUE_NUMBER_INT`, `JsonToken.END_ARRAY`)
    `void` | `writeArray(long[] array, int offset, int length)` Value write method that can be called to write a single array (sequence of `JsonToken.START_ARRAY`, zero or more `JsonToken.VALUE_NUMBER_INT`, `JsonToken.END_ARRAY`)
    `void` | `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
    `int` | `writeBinary(Base64Variant b64variant, InputStream data, int dataLength)` Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
    `void` | `writeBoolean(boolean state)` Method for outputting literal JSON boolean value (one of Strings 'true' and 'false').
    `void` | `writeEmbeddedObject(Object object)` Method that can be called on backends that support passing opaque datatypes of non-JSON formats
    `void` | `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeFieldId(long id)` Alternative to `JsonGenerator.writeFieldName(String)` that may be used in cases where property key is of numeric type; either where underlying format supports such notion (some binary formats do, unlike JSON), or for convenient conversion into String presentation.
    `void` | `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
    `void` | `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
    `void` | `writeNull()` Method for outputting literal JSON null value.
    `void` | `writeNumber(BigDecimal v)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(BigInteger v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(double v)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(float v)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(int v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(long v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(short v)` Method for outputting given value as JSON number.
    `void` | `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
    `void` | `writeObject(Object pojo)` Method for writing given Java object (POJO) as Json.
    `void` | `writeObjectId(Object id)` Method that can be called to output so-called native Object Id.
    `void` | `writeObjectRef(Object id)` Method that can be called to output references to native Object Ids.
    `void` | `writeOmittedField(String fieldName)` Method called to indicate that a property in this position was skipped.
    `void` | `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(char[] text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(SerializableString raw)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
    `void` | `writeRawValue(char[] text, int offset, int len)`
    `void` | `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
    `void` | `writeRawValue(String text, int offset, int len)`
    `void` | `writeStartArray()` Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartArray(int size)` Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying how many elements will be written for the array before calling `JsonGenerator.writeEndArray()`.
    `void` | `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartObject(Object forValue)` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled), to represent Java given as the argument.
    `void` | `writeString(char[] text, int offset, int len)` Method for outputting a String value.
    `void` | `writeString(Reader reader, int len)` Method for outputting a String value.
    `void` | `writeString(SerializableString text)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
    `void` | `writeString(String text)` Method for outputting a String value.
    `void` | `writeTree(TreeNode tree)` Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator.
    `void` | `writeTypeId(Object id)` Method that can be called to output so-called native Type Id.
    `void` | `writeUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

    - ### Methods inherited from class com.hazelcast.com.fasterxml.jackson.core.JsonGenerator

      `_reportError, _reportUnsupportedOperation, _throwInternal, _verifyOffsets, _writeSimpleObject, canWriteFormattedNumbers, configure, getFormatFeatures, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBooleanField, writeNullField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeRawValue, writeStringField, writeTypePrefix, writeTypeSuffix`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### delegate

          protected JsonGenerator delegate

      Delegate object that method calls are delegated to.

    - #### delegateCopyMethods

          protected boolean delegateCopyMethods

      Whether copy methods (`copyCurrentEvent(com.hazelcast.com.fasterxml.jackson.core.JsonParser)`, `copyCurrentStructure(com.hazelcast.com.fasterxml.jackson.core.JsonParser)`, `writeTree(com.hazelcast.com.fasterxml.jackson.core.TreeNode)` and `writeObject(java.lang.Object)`) are to be called (true), or handled by this object (false).

  - ### Constructor Detail

    - #### JsonGeneratorDelegate

          public JsonGeneratorDelegate(JsonGenerator d)

    - #### JsonGeneratorDelegate

          public JsonGeneratorDelegate(JsonGenerator d,
                                       boolean delegateCopyMethods)

      Parameters:
        `delegateCopyMethods` - Flag assigned to `delagateCopyMethod` and which defines whether copy methods are handled locally (false), or delegated to configured

  - ### Method Detail

    - #### getCurrentValue

          public Object getCurrentValue()

      Description copied from class: `JsonGenerator`
      Helper method, usually equivalent to: `getOutputContext().getCurrentValue();`

      Note that "current value" is NOT populated (or used) by Streaming parser; it is only used by higher-level data-binding functionality. The reason it is included here is that it can be stored and accessed hierarchically, and gets passed through data-binding.

      Overrides:
        `getCurrentValue` in class `JsonGenerator`

    - #### setCurrentValue

          public void setCurrentValue(Object v)

      Description copied from class: `JsonGenerator`
      Helper method, usually equivalent to: `getOutputContext().setCurrentValue(v);`
      Overrides:
        `setCurrentValue` in class `JsonGenerator`

    - #### getDelegate

          public JsonGenerator getDelegate()

    - #### getCodec

          public ObjectCodec getCodec()

      Description copied from class: `JsonGenerator`
      Method for accessing the object used for writing Java object as JSON content (using method `JsonGenerator.writeObject(java.lang.Object)`).
      Specified by:
        `getCodec` in class `JsonGenerator`

    - #### setCodec

          public JsonGenerator setCodec(ObjectCodec oc)

      Description copied from class: `JsonGenerator`
      Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).
      Specified by:
        `setCodec` in class `JsonGenerator`
      Returns:
        Generator itself (this), to allow chaining

    - #### setSchema

          public void setSchema(FormatSchema schema)

      Description copied from class: `JsonGenerator`
      Method to call to make this generator use specified schema. Method must be called before generating any content, right after instance has been created. Note that not all generators support schemas; and those that do usually only accept specific types of schemas: ones defined for data format this generator produces.

      If generator does not support specified schema, `UnsupportedOperationException` is thrown.

      Overrides:
        `setSchema` in class `JsonGenerator`
      Parameters:
        `schema` - Schema to use

    - #### getSchema

          public FormatSchema getSchema()

      Description copied from class: `JsonGenerator`
      Method for accessing Schema that this parser uses, if any. Default implementation returns null.
      Overrides:
        `getSchema` in class `JsonGenerator`

    - #### version

          public Version version()

      Description copied from class: `JsonGenerator`
      Accessor for finding out version of the bundle that provided this generator instance.
      Specified by:
        `version` in interface `Versioned`
      Specified by:
        `version` in class `JsonGenerator`

    - #### getOutputTarget

          public Object getOutputTarget()

      Description copied from class: `JsonGenerator`
      Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

      In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

      Overrides:
        `getOutputTarget` in class `JsonGenerator`

    - #### getOutputBuffered

          public int getOutputBuffered()

      Description copied from class: `JsonGenerator`
      Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available. Unit used is often the same as the unit of underlying target (that is, `byte` for `OutputStream`, `char` for `Writer`), but may differ if buffering is done before encoding. Default JSON-backed implementations do use matching units.

      Note: non-JSON implementations will be retrofitted for 2.6 and beyond; please report if you see -1 (missing override)

      Overrides:
        `getOutputBuffered` in class `JsonGenerator`
      Returns:
        Amount of content buffered in internal units, if amount known and accessible; -1 if not accessible.

    - #### canUseSchema

          public boolean canUseSchema(FormatSchema schema)

      Description copied from class: `JsonGenerator`
      Method that can be used to verify that given schema can be used with this generator (using `JsonGenerator.setSchema(com.hazelcast.com.fasterxml.jackson.core.FormatSchema)`).
      Overrides:
        `canUseSchema` in class `JsonGenerator`
      Parameters:
        `schema` - Schema to check
      Returns:
        True if this generator can use given schema; false if not

    - #### canWriteTypeId

          public boolean canWriteTypeId()

      Description copied from class: `JsonGenerator`
      Introspection method that may be called to see if the underlying data format supports some kind of Type Ids natively (many do not; for example, JSON doesn't). This method must be called prior to calling `JsonGenerator.writeTypeId(java.lang.Object)`.

      Default implementation returns false; overridden by data formats that do support native Type Ids. Caller is expected to either use a non-native notation (explicit property or such), or fail, in case it can not use native type ids.

      Overrides:
        `canWriteTypeId` in class `JsonGenerator`

    - #### canWriteObjectId

          public boolean canWriteObjectId()

      Description copied from class: `JsonGenerator`
      Introspection method that may be called to see if the underlying data format supports some kind of Object Ids natively (many do not; for example, JSON doesn't). This method must be called prior to calling `JsonGenerator.writeObjectId(java.lang.Object)` or `JsonGenerator.writeObjectRef(java.lang.Object)`.

      Default implementation returns false; overridden by data formats that do support native Object Ids. Caller is expected to either use a non-native notation (explicit property or such), or fail, in case it can not use native object ids.

      Overrides:
        `canWriteObjectId` in class `JsonGenerator`

    - #### canWriteBinaryNatively

          public boolean canWriteBinaryNatively()

      Description copied from class: `JsonGenerator`
      Introspection method that may be called to see if the underlying data format supports "native" binary data; that is, an efficient output of binary content without encoding.

      Default implementation returns false; overridden by data formats that do support native binary content.

      Overrides:
        `canWriteBinaryNatively` in class `JsonGenerator`

    - #### canOmitFields

          public boolean canOmitFields()

      Description copied from class: `JsonGenerator`
      Introspection method to call to check whether it is ok to omit writing of Object fields or not. Most formats do allow omission, but certain positional formats (such as CSV) require output of placeholders, even if no real values are to be emitted.
      Overrides:
        `canOmitFields` in class `JsonGenerator`

    - #### enable

          public JsonGenerator enable(JsonGenerator.Feature f)

      Description copied from class: `JsonGenerator`
      Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.
      Specified by:
        `enable` in class `JsonGenerator`
      Returns:
        Generator itself (this), to allow chaining

    - #### disable

          public JsonGenerator disable(JsonGenerator.Feature f)

      Description copied from class: `JsonGenerator`
      Method for disabling specified features (check `JsonGenerator.Feature` for list of features)
      Specified by:
        `disable` in class `JsonGenerator`
      Returns:
        Generator itself (this), to allow chaining

    - #### isEnabled

          public boolean isEnabled(JsonGenerator.Feature f)

      Description copied from class: `JsonGenerator`
      Method for checking whether given feature is enabled. Check `JsonGenerator.Feature` for list of available features.
      Specified by:
        `isEnabled` in class `JsonGenerator`

    - #### getFeatureMask

          public int getFeatureMask()

      Description copied from class: `JsonGenerator`
      Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.
      Specified by:
        `getFeatureMask` in class `JsonGenerator`
      Returns:
        Bit mask that defines current states of all standard `JsonGenerator.Feature`s.

    - #### setFeatureMask

          @Deprecated
          public JsonGenerator setFeatureMask(int mask)

      Deprecated.
      Description copied from class: `JsonGenerator`
      Bulk set method for (re)setting states of all standard `JsonGenerator.Feature`s
      Specified by:
        `setFeatureMask` in class `JsonGenerator`
      Parameters:
        `mask` - Bitmask that defines which `JsonGenerator.Feature`s are enabled and which disabled
      Returns:
        This parser object, to allow chaining of calls

    - #### overrideStdFeatures

          public JsonGenerator overrideStdFeatures(int values,
                                                   int mask)

      Description copied from class: `JsonGenerator`
      Bulk set method for (re)setting states of features specified by `mask`. Functionally equivalent to `int oldState = getFeatureMask(); int newState = (oldState & ~mask) | (values & mask); setFeatureMask(newState);` but preferred as this lets caller more efficiently specify actual changes made.
      Overrides:
        `overrideStdFeatures` in class `JsonGenerator`
      Parameters:
        `values` - Bit mask of set/clear state for features to change
        `mask` - Bit mask of features to change

    - #### overrideFormatFeatures

          public JsonGenerator overrideFormatFeatures(int values,
                                                      int mask)

      Description copied from class: `JsonGenerator`
      Bulk set method for (re)setting states of `FormatFeature`s, by specifying values (set / clear) along with a mask, to determine which features to change, if any.

      Default implementation will simply throw an exception to indicate that the generator implementation does not support any `FormatFeature`s.

      Overrides:
        `overrideFormatFeatures` in class `JsonGenerator`
      Parameters:
        `values` - Bit mask of set/clear state for features to change
        `mask` - Bit mask of features to change

    - #### setPrettyPrinter

          public JsonGenerator setPrettyPrinter(PrettyPrinter pp)

      Description copied from class: `JsonGenerator`
      Method for setting a custom pretty printer, which is usually used to add indentation for improved human readability. By default, generator does not do pretty printing.

      To use the default pretty printer that comes with core Jackson distribution, call `JsonGenerator.useDefaultPrettyPrinter()` instead.

      Overrides:
        `setPrettyPrinter` in class `JsonGenerator`
      Returns:
        Generator itself (this), to allow chaining

    - #### getPrettyPrinter

          public PrettyPrinter getPrettyPrinter()

      Description copied from class: `JsonGenerator`
      Accessor for checking whether this generator has a configured `PrettyPrinter`; returns it if so, null if none configured.
      Overrides:
        `getPrettyPrinter` in class `JsonGenerator`

    - #### useDefaultPrettyPrinter

          public JsonGenerator useDefaultPrettyPrinter()

      Description copied from class: `JsonGenerator`
      Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
      Specified by:
        `useDefaultPrettyPrinter` in class `JsonGenerator`
      Returns:
        Generator itself (this), to allow chaining

    - #### setHighestNonEscapedChar

          public JsonGenerator setHighestNonEscapedChar(int charCode)

      Description copied from class: `JsonGenerator`
      Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1). To force escaping of all non-ASCII characters, for example, this method would be called with value of 127.

      Note that generators are NOT required to support setting of value higher than 127, because there are other ways to affect quoting (or lack thereof) of character codes between 0 and 127. Not all generators support concept of escaping, either; if so, calling this method will have no effect.

      Default implementation does nothing; sub-classes need to redefine it according to rules of supported data format.

      Overrides:
        `setHighestNonEscapedChar` in class `JsonGenerator`
      Parameters:
        `charCode` - Either -1 to indicate that no additional escaping is to be done; or highest code point not to escape (meaning higher ones will be), if positive value.

    - #### getHighestEscapedChar

          public int getHighestEscapedChar()

      Description copied from class: `JsonGenerator`
      Accessor method for testing what is the highest unescaped character configured for this generator. This may be either positive value (when escaping configuration has been set and is in effect), or 0 to indicate that no additional escaping is in effect. Some generators may not support additional escaping: for example, generators for binary formats that do not use escaping should simply return 0.
      Overrides:
        `getHighestEscapedChar` in class `JsonGenerator`
      Returns:
        Currently active limitation for highest non-escaped character, if defined; or -1 to indicate no additional escaping is performed.

    - #### getCharacterEscapes

          public CharacterEscapes getCharacterEscapes()

      Description copied from class: `JsonGenerator`
      Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.
      Overrides:
        `getCharacterEscapes` in class `JsonGenerator`

    - #### setCharacterEscapes

          public JsonGenerator setCharacterEscapes(CharacterEscapes esc)

      Description copied from class: `JsonGenerator`
      Method for defining custom escapes factory uses for `JsonGenerator`s it creates.

      Default implementation does nothing and simply returns this instance.

      Overrides:
        `setCharacterEscapes` in class `JsonGenerator`

    - #### setRootValueSeparator

          public JsonGenerator setRootValueSeparator(SerializableString sep)

      Description copied from class: `JsonGenerator`
      Method that allows overriding String used for separating root-level JSON values (default is single space character)

      Default implementation throws `UnsupportedOperationException`.

      Overrides:
        `setRootValueSeparator` in class `JsonGenerator`
      Parameters:
        `sep` - Separator to use, if any; null means that no separator is automatically added

    - #### writeStartArray

          public void writeStartArray()
                               throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).

      Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Specified by:
        `writeStartArray` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeStartArray

          public void writeStartArray(int size)
                               throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying how many elements will be written for the array before calling `JsonGenerator.writeEndArray()`.

      Default implementation simply calls `JsonGenerator.writeStartArray()`.

      Overrides:
        `writeStartArray` in class `JsonGenerator`
      Parameters:
        `size` - Number of elements this array will have: actual number of values written (before matching call to `JsonGenerator.writeEndArray()` MUST match; generator MAY verify this is the case.
      Throws:
        `IOException`

    - #### writeEndArray

          public void writeEndArray()
                             throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Array.

      Specified by:
        `writeEndArray` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeStartObject

          public void writeStartObject()
                                throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Specified by:
        `writeStartObject` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeStartObject

          public void writeStartObject(Object forValue)
                                throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled), to represent Java given as the argument. Argument is offered as metadata, but more importantly it should be assigned as the "current value" for the Object content that gets constructed and initialized.

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartObject` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeEndObject

          public void writeEndObject()
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

      Specified by:
        `writeEndObject` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeFieldName

          public void writeFieldName(String name)
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

      Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

      Specified by:
        `writeFieldName` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeFieldName

          public void writeFieldName(SerializableString name)
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

      Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

      Specified by:
        `writeFieldName` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeFieldId

          public void writeFieldId(long id)
                            throws IOException

      Description copied from class: `JsonGenerator`
      Alternative to `JsonGenerator.writeFieldName(String)` that may be used in cases where property key is of numeric type; either where underlying format supports such notion (some binary formats do, unlike JSON), or for convenient conversion into String presentation. Default implementation will simply convert id into `String` and call `JsonGenerator.writeFieldName(String)`.
      Overrides:
        `writeFieldId` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeArray

          public void writeArray(int[] array,
                                 int offset,
                                 int length)
                          throws IOException

      Description copied from class: `JsonGenerator`
      Value write method that can be called to write a single array (sequence of `JsonToken.START_ARRAY`, zero or more `JsonToken.VALUE_NUMBER_INT`, `JsonToken.END_ARRAY`)
      Overrides:
        `writeArray` in class `JsonGenerator`
      Parameters:
        `array` - Array that contains values to write
        `offset` - Offset of the first element to write, within array
        `length` - Number of elements in array to write, from `offset` to `offset + len - 1`
      Throws:
        `IOException`

    - #### writeArray

          public void writeArray(long[] array,
                                 int offset,
                                 int length)
                          throws IOException

      Description copied from class: `JsonGenerator`
      Value write method that can be called to write a single array (sequence of `JsonToken.START_ARRAY`, zero or more `JsonToken.VALUE_NUMBER_INT`, `JsonToken.END_ARRAY`)
      Overrides:
        `writeArray` in class `JsonGenerator`
      Parameters:
        `array` - Array that contains values to write
        `offset` - Offset of the first element to write, within array
        `length` - Number of elements in array to write, from `offset` to `offset + len - 1`
      Throws:
        `IOException`

    - #### writeArray

          public void writeArray(double[] array,
                                 int offset,
                                 int length)
                          throws IOException

      Description copied from class: `JsonGenerator`
      Value write method that can be called to write a single array (sequence of `JsonToken.START_ARRAY`, zero or more `JsonToken.VALUE_NUMBER_FLOAT`, `JsonToken.END_ARRAY`)
      Overrides:
        `writeArray` in class `JsonGenerator`
      Parameters:
        `array` - Array that contains values to write
        `offset` - Offset of the first element to write, within array
        `length` - Number of elements in array to write, from `offset` to `offset + len - 1`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(String text)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(Reader reader,
                                  int len)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification. If the reader is null, then write a null. If len is < 0, then write all contents of the reader. Otherwise, write only len characters.
      Overrides:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(char[] text,
                                  int offset,
                                  int len)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeString

          public void writeString(SerializableString text)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

      Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRawUTF8String

          public void writeRawUTF8String(byte[] text,
                                         int offset,
                                         int length)
                                  throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Specified by:
        `writeRawUTF8String` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeUTF8String

          public void writeUTF8String(byte[] text,
                                      int offset,
                                      int length)
                               throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Specified by:
        `writeUTF8String` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(String text)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(String text,
                               int offset,
                               int len)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(SerializableString raw)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      The default implementation delegates to `JsonGenerator.writeRaw(String)`; other backends that support raw inclusion of text are encouraged to implement it in more efficient manner (especially if they use UTF-8 encoding).

      Overrides:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(char[] text,
                               int offset,
                               int len)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRaw

          public void writeRaw(char c)
                        throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRawValue

          public void writeRawValue(String text)
                             throws IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.
      Specified by:
        `writeRawValue` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRawValue

          public void writeRawValue(String text,
                                    int offset,
                                    int len)
                             throws IOException

      Specified by:
        `writeRawValue` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeRawValue

          public void writeRawValue(char[] text,
                                    int offset,
                                    int len)
                             throws IOException

      Specified by:
        `writeRawValue` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeBinary

          public void writeBinary(Base64Variant b64variant,
                                  byte[] data,
                                  int offset,
                                  int len)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

      Note: because JSON Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

      Specified by:
        `writeBinary` in class `JsonGenerator`
      Parameters:
        `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
      Throws:
        `IOException`

    - #### writeBinary

          public int writeBinary(Base64Variant b64variant,
                                 InputStream data,
                                 int dataLength)
                          throws IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
      Specified by:
        `writeBinary` in class `JsonGenerator`
      Parameters:
        `b64variant` - Base64 variant to use
        `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
        `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
      Returns:
        Number of bytes read from `data` and written as binary payload
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(short v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(int v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(long v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(BigInteger v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(double v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(float v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(BigDecimal v)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `v` - Number value to write
      Throws:
        `IOException`

    - #### writeNumber

          public void writeNumber(String encodedValue)
                           throws IOException,
                                  UnsupportedOperationException

      Description copied from class: `JsonGenerator`
      Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `JsonGenerator.writeString(java.lang.String)` method can not be used; nor `JsonGenerator.writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

      Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary JSON format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or JSON nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `UnsupportedOperationException` - If underlying data format does not support numbers serialized textually AND if generator is not allowed to just output a String instead (Schema-based formats may require actual number, for example)
        `IOException`

    - #### writeBoolean

          public void writeBoolean(boolean state)
                            throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting literal JSON boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeBoolean` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeNull

          public void writeNull()
                         throws IOException

      Description copied from class: `JsonGenerator`
      Method for outputting literal JSON null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNull` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeOmittedField

          public void writeOmittedField(String fieldName)
                                 throws IOException

      Description copied from class: `JsonGenerator`
      Method called to indicate that a property in this position was skipped. It is usually only called for generators that return `false` from `JsonGenerator.canOmitFields()`.

      Default implementation does nothing.

      Overrides:
        `writeOmittedField` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeObjectId

          public void writeObjectId(Object id)
                             throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called to output so-called native Object Id. Note that it may only be called after ensuring this is legal (with `JsonGenerator.canWriteObjectId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.
      Overrides:
        `writeObjectId` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeObjectRef

          public void writeObjectRef(Object id)
                              throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called to output references to native Object Ids. Note that it may only be called after ensuring this is legal (with `JsonGenerator.canWriteObjectId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.
      Overrides:
        `writeObjectRef` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeTypeId

          public void writeTypeId(Object id)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called to output so-called native Type Id. Note that it may only be called after ensuring this is legal (with `JsonGenerator.canWriteTypeId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.
      Overrides:
        `writeTypeId` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeEmbeddedObject

          public void writeEmbeddedObject(Object object)
                                   throws IOException

      Description copied from class: `JsonGenerator`
      Method that can be called on backends that support passing opaque datatypes of non-JSON formats
      Overrides:
        `writeEmbeddedObject` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeObject

          public void writeObject(Object pojo)
                           throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing given Java object (POJO) as Json. Exactly how the object gets written depends on object in question (ad on codec, its configuration); for most beans it will result in JSON Object, but for others JSON Array, or String or numeric value (and for nulls, JSON null literal. NOTE: generator must have its object codec set to non-null value; for generators created by a mapping factory this is the case, for others not.
      Specified by:
        `writeObject` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### writeTree

          public void writeTree(TreeNode tree)
                         throws IOException

      Description copied from class: `JsonGenerator`
      Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator. This will generally just call `JsonGenerator.writeObject(java.lang.Object)` with given node, but is added for convenience and to make code more explicit in cases where it deals specifically with trees.
      Specified by:
        `writeTree` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### copyCurrentEvent

          public void copyCurrentEvent(JsonParser p)
                                throws IOException

      Description copied from class: `JsonGenerator`
      Method for copying contents of the current event that the given parser instance points to. Note that the method will not copy any other events, such as events contained within JSON Array or Object structures.

      Calling this method will not advance the given parser, although it may cause parser to internally process more data (if it lazy loads contents of value events, for example)

      Overrides:
        `copyCurrentEvent` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### copyCurrentStructure

          public void copyCurrentStructure(JsonParser p)
                                    throws IOException

      Description copied from class: `JsonGenerator`
      Method for copying contents of the current event and following events that it encloses the given parser instance points to.

      So what constitutes enclosing? Here is the list of events that have associated enclosed events that will get copied:

      - `JsonToken.START_OBJECT`: all events up to and including matching (closing) `JsonToken.END_OBJECT` will be copied
      - `JsonToken.START_ARRAY` all events up to and including matching (closing) `JsonToken.END_ARRAY` will be copied
      - `JsonToken.FIELD_NAME` the logical value (which can consist of a single scalar value; or a sequence of related events for structured types (JSON Arrays, Objects)) will be copied along with the name itself. So essentially the whole field entry (name and value) will be copied.

      After calling this method, parser will point to the last event that was copied. This will either be the event parser already pointed to (if there were no enclosed events), or the last enclosed event copied.

      Overrides:
        `copyCurrentStructure` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### getOutputContext

          public JsonStreamContext getOutputContext()

      Specified by:
        `getOutputContext` in class `JsonGenerator`
      Returns:
        Context object that can give information about logical position within generated json content.

    - #### flush

          public void flush()
                     throws IOException

      Description copied from class: `JsonGenerator`
      Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
      Specified by:
        `flush` in interface `Flushable`
      Specified by:
        `flush` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Description copied from class: `JsonGenerator`
      Method called to close this generator, so that no more content can be written.

      Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in class `JsonGenerator`
      Throws:
        `IOException`

    - #### isClosed

          public boolean isClosed()

      Description copied from class: `JsonGenerator`
      Method that can be called to determine whether this generator is closed or not. If it is closed, no more output can be done.
      Specified by:
        `isClosed` in class `JsonGenerator`

Copyright © 2019. All rights reserved.